'use strict';
const {
  Model,
  INTEGER
} = require('sequelize');
module.exports = (sequelize, DataTypes) => {
  class question extends Model {
    static associate(models) {
      question.belongsTo(models.quiz,{
        foreignKey:'quiz_id',
        onDelete:'cascade'
      })
      question.hasMany(models.option, { foreignKey: 'question_id' , as:'options'});
      question.hasOne(models.option, { foreignKey: 'question_id' , as:'correctOption',scope:{is_correct:true}});

    }
  }
  question.init({
    quiz_id: {
      type:DataTypes.INTEGER,
      allowNull:false
    },
    question_text: {
      type:DataTypes.STRING,
      allowNull:false
    }
  }, {
    sequelize,
    modelName: 'question',
    tableName:'questions',
    timestamps:true
  });
  return question;
};