'use strict';

/** @type {import('sequelize-cli').Migration} */
module.exports = {
  async up (queryInterface, Sequelize) {
    await queryInterface.bulkInsert('quizzes', [
      {
        id:1,
        title: 'Math Quiz',
        description: 'Basic math questions',
        createdAt: new Date(),
        updatedAt: new Date()
      },
      {
        id:2,
        title: 'Science Quiz',
        description: 'General science',
        createdAt: new Date(),
        updatedAt: new Date()
      }
    ]);
    const mathsQuizId=1
    await queryInterface.bulkInsert('questions', [
      {
        quiz_id: mathsQuizId,
        question_text: 'What is 2 + 2?',
        createdAt: new Date(),
        updatedAt: new Date()
      },
      {
        quiz_id: mathsQuizId,
        question_text: 'What is 10 - 4?',
        createdAt: new Date(),
        updatedAt: new Date()
      }
    ]);
    await queryInterface.bulkInsert('options', [
      {
        question_id: 1,
        option_text: '3',
        is_correct: false,
        createdAt: new Date(),
        updatedAt: new Date()
      },
      {
        question_id: 1,
        option_text: '4',
        is_correct: true,
        createdAt: new Date(),
        updatedAt: new Date()
      },
      {
        question_id: 1,
        option_text: '5',
        is_correct: false,
        createdAt: new Date(),
        updatedAt: new Date()
      },
      {
        question_id: 2,
        option_text: '5',
        is_correct: false,
        createdAt: new Date(),
        updatedAt: new Date()
      },
      {
        question_id: 2,
        option_text: '6',
        is_correct: true,
        createdAt: new Date(),
        updatedAt: new Date()
      },
      {
        question_id: 2,
        option_text: '7',
        is_correct: false,
        createdAt: new Date(),
        updatedAt: new Date()
      }
    ]);


  },

  async down (queryInterface, Sequelize) {
     await queryInterface.bulkDelete('quizzes', null, {});
     await queryInterface.bulkDelete('questions', null, {});
     await queryInterface.bulkDelete('options', null, {});
  }
};
